



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>nginx 日志切割（也适用于docker）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">nginx 日志切割（也适用于docker）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-10 20:04:47 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>===============================================</p>
<p>2019/4/6_第2次修改&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;ccb_warlock</p>
<p>2019/4/6：修复原先脚本无法正确保存日志的问题；</p>
<p>===============================================</p>
<p>配置了记录日志的nginx，在运行较长时间后，产生的日志文件（access.log）会越来越大。</p>
<p>日志文件过大会带来下面的问题：</p>
<ul><li>查询过大的日志文件对于开发和运维十分不方便，特别是加班人很累的情况下更加雪上加霜；</li>
<li>很久以前的日志文件几乎没有价值，但是手工清理又太过繁琐；</li></ul>
<p>这时候就需要一种解决方案可以自动来做日志分割，分割后的日志不仅&ldquo;干净&rdquo;，也便于实现日志定时清理。</p>
<p>由于目前的nginx使用docker部署，而公司的业务大都需要nginx始终运行，网上的&ldquo;停nginx，分割，重启nginx&rdquo;的方案并不适合，故对网上的方案进行了改进，使得目前的方案也能适应业务运行要求。</p>
<hr />
<h1><strong>一、前提条件</strong></h1>
<ul><li>本次部署docker的基础os选择centos 7</li>
<li>本次通过swarm的stack方式部署了nginx容器（<a href="https://www.cnblogs.com/straycats/p/9388219.html" rel="external nofollow noreferrer">https://www.cnblogs.com/straycats/p/9388219.html</a>）</li>
<li>本次nginx容器的日志文件持久化在宿主机的目录（/usr/docker-vol/nginx/logs）下</li>
<li>本次每天0:00做日志切割，将切割后的日志文件（access.log、error.log）存放在宿主机的目录（/usr/docker-vol/nginx/logs-bak）下</li>
<li><p>期望的日志备份目录结构：<br />1级目录：4位年-2位月<br />2级目录：4位年-2位月-2位日<br />3级目录：存放切割后备份的日志文件</p></li></ul>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/901201/201904/901201-20190406230832798-1059311246.png" /></p>
<hr />
<h1><strong>二、配置nginx容器的日志切割</strong></h1>
<h2><strong>2.1 编辑cutlogs.sh</strong></h2>
<div>
<pre class="prettyprint linenums">mkdir -p /opt/sh<br />
vi /opt/sh/cutlogs.sh</pre>
</div>
<p># 将下面的内容添加到cutlogs.sh内，wq保存。</p>
<div>
<pre class="prettyprint linenums">#!/bin/bash

# 指定日志和切割后日志备份的目录<br />
YEAR=$(date +%Y)<br />
MONTH=$(date +%m)<br />
DAY=$(date +%d)<br />
YESTERDAY=$(date -d "yesterday" +%Y-%m-%d)<br />
LOGS_PATH=/usr/docker-vol/nginx/logs<br />
LOGS_BAK_PATH=/usr/docker-vol/nginx/logs-bak

# 得到1级目录名<br />
if [[ $(($DAY)) -eq 1 ]]<br />
  then<br />
    if [[ $(($MONTH)) -eq 1 ]]<br />
      then<br />
        LOGS_BAK_PATH=$LOGS_BAK_PATH/$((${YEAR}-1))-12<br />
    else<br />
      if [[ $(($MONTH)) -gt 10 ]]<br />
        then<br />
          LOGS_BAK_PATH=$LOGS_BAK_PATH/${YEAR}-$((${MONTH}-1))<br />
      else<br />
          LOGS_BAK_PATH=$LOGS_BAK_PATH/${YEAR}-0$((${MONTH}-1))<br />
      fi<br />
    fi<br />
else<br />
    LOGS_BAK_PATH=$LOGS_BAK_PATH/${YEAR}-${MONTH}<br />
fi

# 创建目录<br />
mkdir -p $LOGS_BAK_PATH/${YESTERDAY}

# 复制当前的日志文件到备份的目录<br />
cp ${LOGS_PATH}/access.log ${LOGS_BAK_PATH}/${YESTERDAY}/access_${YESTERDAY}.log<br />
cp ${LOGS_PATH}/admin_access.log ${LOGS_BAK_PATH}/${YESTERDAY}/admin_access_${YESTERDAY}.log<br />
cp ${LOGS_PATH}/error.log ${LOGS_BAK_PATH}/${YESTERDAY}/error_${YESTERDAY}.log

# 清空日志<br />
&gt; ${LOGS_PATH}/access.log<br />
&gt; ${LOGS_PATH}/admin_access.log<br />
&gt; ${LOGS_PATH}/error.log</pre>
</div>
<h2><strong>2.2 给<strong>cutlogs.sh</strong>增加权限</strong></h2>
<div>
<pre class="prettyprint linenums">chmod 777 /opt/sh/cutlogs.sh</pre>
</div>
<p>PS.在创建定时任务之前，可以用下面的命令先试验脚本是否存在问题</p>
<div>
<pre class="prettyprint linenums">bash /opt/cutlogs.sh</pre>
</div>
<hr />
<h1><strong>三、创建定时任务</strong></h1>
<h2><strong>3.1&nbsp;编辑crontab</strong></h2>
<div>
<pre class="prettyprint linenums">vi /etc/crontab</pre>
</div>
<p># 将下面的内容添加到crontab文件中，wq保存。</p>
<div>
<pre class="prettyprint linenums"># 每天0:00执行该脚本<br />
0 0 * * * root bash /opt/sh/cutlogs.sh</pre>
</div>
<h2><strong>3.2&nbsp;重启crontab</strong></h2>
<div>
<pre class="prettyprint linenums">systemctl restart crond</pre>
</div>
<p>根据这个方案切割后的日志文件会根据这样的结构进行存放。</p>
<hr />
<h1><strong>后话：</strong></h1>
<p>不停机做日志切割可能会出现日志记录丢失的情况（即拷贝走、清空源文件之间会有时间间隔），但是对于目前的业务，一天的日志信息量不大且丢失的日志对于整天的日志来说犹如沧海一粟，故现在先用这个方案来解决docker部署后的nginx日志切割。</p>
<hr />
<h1><strong>参考资料：</strong></h1>
<p>1.<a href="http://www.cnblogs.com/wjoyxt/p/4757093.html" rel="external nofollow noreferrer">http://www.cnblogs.com/wjoyxt/p/4757093.html</a></p>
<p>2.<a href="https://blog.csdn.net/linglongwunv/article/details/5212700" rel="external nofollow noreferrer">https://blog.csdn.net/linglongwunv/article/details/5212700</a></p>
<p>3.<a href="http://www.cnblogs.com/wjoyxt/p/4757093.html" rel="external nofollow noreferrer">http://www.cnblogs.com/wjoyxt/p/4757093.html</a></p>
<p>4.<a href="https://www.cnblogs.com/aaronLinux/p/7074725.html" rel="external nofollow noreferrer">https://www.cnblogs.com/aaronLinux/p/7074725.html</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7jmkqe.html">Entity Framework 6 Recipes 2nd Edition（9-5）译-&amp;gt&semi;删除一个断开的实体</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvpryqx.html">构建ASP&period;NET MVC4&plus;EF5&plus;EasyUI&plus;Unity2&period;x注入的后台管理系统（10）-系统菜单栏&lbrack;附源码&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kjr2j9.html">ECMAScript</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy6xox8.html">重建Windows 8的图标缓存</a>
		</li>
						<li><a href="https://www.batexi.com/a/r934o4r8.html">mysql登录基本语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e11k1z9.html">cf&lpar;&num;div1 B&period; Dreamoon and Sets&rpar;&lpar;数论&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1jgdx8.html">HDU 5067</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k124w79.html">POJ 2762 Going from u to v or from v to u&quest; &lpar;强连通分量缩点&plus;拓扑排序&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnzl208.html">POJ1265&mdash;&mdash;Area&lpar;Pick定理&plus;多边形面积&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zdyn59.html">hyperlink</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdex3mx9.html">POJ 2777&lpar;线段树&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y2xy5q.html">Linux文件虚拟机系统只读Read-only file system的快速解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmylje9.html">如何：在 StackPanel 和 DockPanel 之间进行选择</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kkokz9.html">华丽的网上突出代码组件CodeMirror</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z1omk9.html">BZOJ4079 &lbrack;Wf2014&rsqb;Pachinko</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp3j5j9.html">Windows下利用MKL加速caffe，与openblas比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj2nw39.html">IIS多个应用程序共享Session</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gnlneq.html">JMeter&mdash;后置处理器&lpar;十&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjkz7l9.html">hots团队项目终审报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1omzl9.html">一些常见的第三方UI库</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9rnze5mq.html">asp&period;net简述MVC开发模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdj06ljq.html">美团 OCTO 分布式服务治理系统</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2kww5oq.html">Play with Floor and Ceil UVA - 10673（拓展欧几里得）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vzze4q.html">「TJOI &sol; HEOI2016」字符串</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jm0zx09.html">【CF949D】Curfew（贪心）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rndgj4q.html">Problem A&colon; 道路建设 解题报告</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rnd51mq.html">raft 论文</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2n2308.html">&lbrack;转&rsqb;Robotium环境搭建中的Errors running builder &amp;&num;39&semi;Android Resource Manag</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1mo0k9.html">What does -1 mean in numpy reshape&quest;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o4kdxxq.html">Tomcat权威指南-读书摘要系列10</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
